/*!
 * \file    DefvalWindow.hpp
 * \brief   Defval class for visual_YAO.
 * \version 2009/12/26 (yyyy/mm/dd)
 * \author  MAYAKI Abdouramane & MAYOMBO Alexis.
 */
#ifndef DEFVALWINDOW_HPP
#define DEFVALWINDOW_HPP

#include <QWidget>
#include <QTextStream>
#include <QPushButton>
#include <QGridLayout>
#include <QLineEdit>
#include <QStandardItemModel>
#include <QTableWidget>
#include <QString>
#include <QFileDialog>
#include <QStringListModel>
#include <QStringList>
#include <QLabel>
#include <QIODevice>
#include <QMessageBox>

//using namespace std;

class DefvalWindow : public QWidget {

	Q_OBJECT;

	public :
            /*!
             *  \brief Constructor
             *
             *  Constructor of the class SpaceWindow
             *
             *  \param  Table<Constant> theConstantTable
             */   
         
                DefvalWindow(QWidget *parent=0);   /*!< This function returns the constante's data. */
		void addNameInTable(int ligne, int colonne, QString nomDefval);
                void addValueInTable(int ligne, int colonne, QString valeurDefval);
		void addRow();
		bool testContenu(int anInt);
               QStringList getDataDefval(); 
                
	public slots :        /*!< Functions called after a click. */

		void addDefvalRow();    /*!< This function is called to add row in the visual window model. */
                void deleteDefvalRow(); /*!< This function is called to delete row from the Yao model. */ 
		void initialiserChamps(); 
                void callDefvalHelp();
                void ouvrirProjetExistant();
		void saveDefvalData();  /*!< This function is called to add data in the Yao model. */
                //void fermerEnrDef();


	private :

                QLabel 	*m_labelNomDefval;   /*!< QLabel for the Constante Name. */
		QLabel	*m_labelValeurDefval;  /*!< QLabel for the Constante value.  */           	

		QLineEdit *m_ligneNomDefval;   /*!< QLineEdit for the Constante Name. */
            	QLineEdit *m_ligneValeurDefval;  /*!< QLineEdit for the Constante Name. */

                QPushButton *m_ajoutDefval;    /*!< The button "add". */
                QPushButton *m_supDefval;     /*!< The button "delete". */
		QPushButton *m_saveDefvalButton;  /*!< The button "save". */
		QPushButton *m_quitDefval;    /*!< The button "close window". */
                QPushButton *m_DefvalHelpButton;  /*!< The button "Help". */

            	QGridLayout *m_layoutGDefval;  //!< QGridLayout for m_layoutGDefval  		
		QHBoxLayout *m_layoutH1Defval;   //!< QHBoxLayout m_layoutH1Defval
                
		QStandardItemModel *modeleDefval;
                QTableWidget *vueDefval;  /*!< Name of the QTableWidget's object in whitch the objects are listed for the viewer. */

                QFileDialog *fd;
                QModelIndex index;

                QString lstF;
                QStringList m_listeNomsDefval;
                QStringList m_listeValeursDefval;
                QStringListModel *m_modeleListeNoms;
                QStringList defvalData;

                bool isCalled;
                
                int compteur;


};

#endif
